# Overview

InspIRCd (www.inspircd.org) is an IRC server that integrates well with
LDAP authentication.  This charm will install and configure the inspircd
package.  A working knowledge of inspircd is assumed.

See http://www.inspircd.org and https://wiki.inspircd.org/Configuration
for more details on the various options.

# Installation

To deploy this charm you will need at a minimum: a cloud environment,
working Juju installation and a successful bootstrap. Once bootstrapped,
deploy the inspircd charm:

    juju deploy inspircd

You will likely need an SSL key and certificate, which can be delivered
to the charm thusly:

    juju set ca_certificate="$(base64 -w0 < /path/to/ca-cert.pem)" \
         ssl_key="$(base64 -w0 < /path/to/key.pem)" \
         ssl_certificate="$(base64 -w0 < /path/to/certificate.pem)" \
        
for evaluation, you can do this instead, to disable ssl usage:

    juju set inspircd ssl_ports=''

Finally, expose the service:

    juju expose inspircd

# Usage


## Known Limitations and Issues

- The ldapauth support requires a version of inspircd that has fixes
  for:
  https://bugs.launchpad.net/ubuntu/+source/inspircd/+bug/1428209
        consistent handling of user:pass format
  You will also likely want:
  https://bugs.launchpad.net/ubuntu/+source/inspircd/+bug/1437044 for
  the logging enhancements.
- The logrotate support requires that this fix be present:
  https://bugs.launchpad.net/ubuntu/+source/inspircd/+bug/1437030

TODO:

LATER:

# Contact Information

LaMont Jones <lamont.jones@canonical.com>
