#!/usr/bin/python

import errno
import base64
import subprocess
import os
import grp
import errno

from charmhelpers.core.hookenv import (
    config,
)

from charmhelpers.contrib.charmsupport.nrpe import NRPE
from charmhelpers.core import host
from charmhelpers.fetch import apt_hold


def install_file(source, target, mode):
    src = os.sep.join([os.environ["CHARM_DIR"], source])
    try:
        os.fdopen(os.open(target, os.O_WRONLY | os.O_CREAT, mode),"w").write(open(src).read())
    except OSError, err:
        if err.errno != errno.ENOENT:
            raise err


def install_package(service_name):
    conf = config()
    if conf['yaml']['ssl_ports']:
        if conf['crl_filename']:
            # make sure that the CRL file (if any) exists
            try:
                open(conf['crl_filename'], "r")
            except IOError, e:
                if e.errno != errno.ENOENT:
                    raise e
                open(conf['crl_filename'], "w")
        # output the ssl key matter
        open("/etc/inspircd/ssl.cert", "w").write(str(base64.b64decode(conf['ssl_certificate'])))
        open("/etc/inspircd/ca.crt", "w").write(str(base64.b64decode(conf['ca_certificate'])))
        old_umask = os.umask(027)
        open("/etc/inspircd/ssl.key.in", "w").write(str(base64.b64decode(conf['ssl_key'])))
        subprocess.call(["certtool", "-k"], stdin=open("/etc/inspircd/ssl.key.in"), stdout=open("/etc/inspircd/ssl.key", "w"))
        os.chown('/etc/inspircd/ssl.key', 0, grp.getgrnam('irc').gr_gid)
        os.umask(old_umask)

    open("/etc/inspircd/inspircd.motd", "w").write(conf['motd'])

    install_file("files/apparmor", "/etc/apparmor.d/usr.sbin.inspircd", 0644)
    install_file("files/check_apparmor_profile", "/usr/lib/nagios/plugins/check_apparmor_profile", 0755)

    if conf['hold_package']:
        apt_hold(['inspircd'], fatal=True)
    else:
        subprocess.call(["apt-mark", "unhold", "inspircd"])

    nrpe_compat = NRPE()
    nrpe_compat.add_check(
        shortname="ircd",
        description="Check IRCd",
        check_cmd='/usr/lib/nagios/plugins/check_ircd_ssl',
    )
    nrpe_compat.write()


def inspircd_reload(service_name):
    host.service_reload('inspircd', restart_on_failure=True)


def enable_apparmor_profile(service_name):
    if subprocess.call(['/bin/running-in-container']) != 0:
        subprocess.call(["apparmor_parser", "-r", "/etc/apparmor.d/usr.sbin.inspircd"])
